=== debian/changelog ===
glslang (15.1.0+1.4.309.0-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 25 Oct 2025 12:05:34 -0700

glslang (15.1.0+1.4.309.0-1) unstable; urgency=medium

  * New upstream release from vulkan-sdk-1.4.309.0 -tag.
  * control: Bump spirv-tools depends.
  * patches: Refresh pkgconfig patch.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 18 Mar 2025 19:32:57 +0200
