=== debian/control ===
Source: glslang
Section: libdevel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               pkgconf,
               python3:native,
               spirv-headers,
               spirv-tools (>= 2025.1~rc1)
Standards-Version: 4.7.0
Homepage: https://github.com/KhronosGroup/glslang
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/glslang.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/glslang

Package: glslang-tools
Architecture: any
Multi-Arch: foreign
Depends: spirv-tools (>= 2025.1~rc1), ${misc:Depends}, ${shlibs:Depends}
Description: OpenGL and OpenGL ES shader front end and validator -- tools
 glslang is the official reference compiler front end for the OpenGL ES
 and OpenGL shading languages. It implements a strict
 interpretation of the specifications for these languages.
 .
 This package includes the validator tools.

Package: glslang-dev
Architecture: any
Depends: spirv-tools (>= 2025.1~rc1), ${misc:Depends}
Suggests: glslang-tools
Multi-Arch: same
Description: OpenGL and OpenGL ES shader front end and validator -- development files
 glslang is the official reference compiler front end for the OpenGL ES
 and OpenGL shading languages. It implements a strict
 interpretation of the specifications for these languages.
 .
 This package includes files for development.
