=== debian/tests/control ===
Tests: glslang-dev
Restrictions: allow-stderr, superficial
Depends: build-essential, glslang-dev, pkg-config

Tests: glslang-tools
Restrictions: allow-stderr, superficial
Depends: glslang-tools
