=== SPIRV/CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,7 @@
 
 set(SPIRV_HEADERS
     ${CMAKE_CURRENT_SOURCE_DIR}/bitutils.h
-    ${CMAKE_CURRENT_SOURCE_DIR}/spirv.hpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/spirv.hpp11
     ${CMAKE_CURRENT_SOURCE_DIR}/GLSL.std.450.h
     ${CMAKE_CURRENT_SOURCE_DIR}/GLSL.ext.EXT.h
     ${CMAKE_CURRENT_SOURCE_DIR}/GLSL.ext.KHR.h
@@ -58,6 +58,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/Logger.h
     ${CMAKE_CURRENT_SOURCE_DIR}/SpvBuilder.h
     ${CMAKE_CURRENT_SOURCE_DIR}/spvIR.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/spvUtil.h
     ${CMAKE_CURRENT_SOURCE_DIR}/doc.h
     ${CMAKE_CURRENT_SOURCE_DIR}/SpvTools.h
     ${CMAKE_CURRENT_SOURCE_DIR}/disassemble.h
@@ -77,7 +78,7 @@
     GlslangToSpv.h
     disassemble.h
     Logger.h
-    spirv.hpp
+    spirv.hpp11
     SPVRemapper.h
     SpvTools.h)
