=== debian/changelog ===
glslang (15.4.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump spirv-tools depends.
  * patches: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 11 Aug 2025 07:08:31 +0300
