=== debian/rules ===
--- 
+++ 
@@ -17,11 +17,6 @@
 override_dh_auto_test:
 endif
 
-# No dbgsym packages:
-override_dh_strip:
-	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
-	dh_strip --no-automatic-dbgsym
-
 gentarball: SOURCE=glslang
 gentarball: UV=$(shell echo ${DEB_VERSION}|sed 's/-.*$$//')
 gentarball:
